// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.0 (2006/06/28)

#ifndef WM4IMAGECATALOG_H
#define WM4IMAGECATALOG_H

#include "Wm4GraphicsLIB.h"
#include "Wm4Object.h"
#include "Wm4MainMCR.h"

namespace Wm4
{

class Image;

class WM4_GRAPHICS_ITEM ImageCatalog
{
public:
    ImageCatalog (const std::string& rkName);
    ~ImageCatalog ();

    const std::string& GetName () const;
    bool Insert (Image* pkImage);
    bool Remove (Image* pkImage);
    Image* Find (const std::string& rkImageName);
    bool PrintContents (const std::string& rkFilename) const;

    static void SetActive (ImageCatalog* pkActive);
    static ImageCatalog* GetActive ();

private:
    std::string m_kName;
    std::map<std::string,Image*> m_kEntry;
    ObjectPtr m_spkDefaultImage;

    static const std::string ms_kNullString;
    static const std::string ms_kDefaultString;
    static ImageCatalog* ms_pkActive;
};

}

#endif
